# Flood Expanded

It contains a bit of helpful information, like the level codes for certain levels,
as well as commands. It also contains helpful information for modders.

If you can't find help here, i would reccomend joining this server.

https://discord.gg/8PxMf4PZ62

## Useful Information

### Level Codes

You can find these in `a-levels.lua`

```
bob = Bomb-Omb Battlefield
wf = Whomp's Fortress
ccm = Cool Cool Mountain
bitdw = Bowser in the Dark World
bbh = Big Boo's Haunt
hmc = Hazy Maze Cave
lll-volcano = Lethal Lava Land's Volcano
ssl-pyramid = Shifting Sand Land's Pyramid
wdw = Wet Dry World
ttm = Tall Tall Mountain
thi = Tiny Huge Island
ttc = Tick Tock Clock
bits = Bowser in the Sky
ctt = Climb The Tower
up = Underground Platforms
rr = Rainbow Ride
jrb = Jolly Roger Bay
ddd = Dire Dire Docks
fcs = Freezing Cold Slopes
vcutm = Vanish Cap under the Moat
wing = Tower of the Wing Cap
metal = Cavern of the Metal Cap
tpss = The Princess's Secret Slide
castle-grounds = Castle Grounds
bitfs = Bowser in the Fire Sea
cs = Crystal Slide
mc = Mountain Chog
construct = gm_construct
birdslair = Bird's Lair
ccm-slide = Cool Cool Mountain's Slide
thi-small = Tiny Huge Island's Small Variant
thi-w8rc = Tiny Huge Island's Wiggler's 8 Red Coin's Star
jrb-ship = Jolly Roger Bay's Ship
lll = Lethal Lava Land
ssl = Shifting Sand Land
```

### Commands

```
/flood start random
/flood random
/flood modifiers [NSMB, Instakill, Reds, Trollface]
/flood mapmode [Default, Random]
/flood difficulty [number between 0-10]
/flood info
```

If you have NSMB Modifier on:
`/flood coincount [number]`

## Modder "Guides"

### Scripts

- main.lua - Contains most of the actual code for flood and its modifiers
- misc.lua - Contains behavior data and misc functions
- a-utils.lua - Contains custom functions n stuff
- a-levels.lua - Contains most of the level data for the positions of flags and stuff
- spectator.lua - Contains Flood's camera system
- level-info.lua - Contains level information, like name and author
- audio.lua - Custom audio system Cooliokid956 made
- doors.lua - Opens doors that are near (EmeraldLockdown wanted me to add this (tysm - EmeraldLockdown))

### Folders

- .vs - Ignore this
- actors - Contains actors or models and collisions
- levels - Contains custom levels
- sound - Contains music and sfx
- textures - Contains textures (mostly unused)

### Common Questions

Q: How do i put flags in a custom level?

A: In a-levels.lua, you can set the flag position.
